<?php
if (!defined( 'ABSPATH' )) exit;
class woo2app_core_api_shipping_methods {
	public function __construct(){
		add_action( 'init', array( $this , 'woo2app_api_regular_url' ));
		add_filter( 'query_vars', array( $this , 'woo2app_api_query_vars' ));
		add_action( 'parse_request', array( $this , 'woo2app_api_parse_request' ));
	}
	function woo2app_api_regular_url(){
		add_rewrite_rule('', 'index.php?GET_shipping_methods', 'top');
	}
	function woo2app_api_query_vars($query_vars){
		$query_vars[] = 'GET_shipping_methods';
		return $query_vars;
	}
	function woo2app_api_parse_request(&$wp){
		if ( array_key_exists( 'GET_shipping_methods' , $wp->query_vars ) ) {
			$this->woo2app_GET_shipping_methods();
			exit();
		}
		return;
	}
	function woo2app_GET_shipping_methods(){

		try {
			$in = $_POST['in'];
			$slashless = stripcslashes($in);
			$url_json = urldecode($slashless);
			$json = (array) json_decode($url_json);

			$package = array();
			$package['contents'] = array();
			$entity_body = $json;//json_decode(file_get_contents('php://input'));
			$line_items = $entity_body["items"];


			foreach ($line_items as $line_item) {
				wc()->cart->add_to_cart( $line_item->product_id , $line_item->quantity , $line_item->variation_id  );
			}

			//wc()->cart->applied_coupons = ['percent_10'];
			wc()->cart->applied_coupons = [$json['coupon_lines'][0]->code];
			$cart = wc()->cart->get_shipping_packages();
			$ar = array();
			foreach($cart as $index => $value){
				$ar = $value;
			}
			$ar["destination"]["country"] = $entity_body["shipping"]->country;
			$ar["destination"]["state"] = $entity_body["shipping"]->state;
			$sm =  wc()->shipping->calculate_shipping_for_package($ar);

			$rates = array();
			foreach($sm["rates"] as $index => $value)
			{
				$rates[] = $value;
			}
			$sm["rates"] = $rates;
			WC()->session->set( 'applied_coupons', array() );
			echo json_encode($sm);

		} catch (\Exception $e) {
			wp_send_json_error(array('message' => $e->getMessage()));
		}

	}
}